﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

using System.Drawing.Drawing2D;

namespace WinFormsCustomPensAndPaths {
	public partial class Form1 : Form {
		public Form1() {
			InitializeComponent();
		}

		protected override void OnPaint(PaintEventArgs e) {
			Graphics g = e.Graphics;

			Pen p = new Pen(Color.Black, 20);

			// g.DrawLine(p, 50, 50, 200, 100);
			// g.DrawLine(p, 200, 100, 100, 400);

			p.LineJoin = System.Drawing.Drawing2D.LineJoin.Round;
			p.StartCap = System.Drawing.Drawing2D.LineCap.Round;

			g.DrawLines(p, new[] { new Point(50, 50), new Point(200, 100), new Point(100, 400) });

			var path = new GraphicsPath();
			path.AddLine(50, 50, 100, 100);
			path.AddLine(100, 100, 200, 100);
			path.AddCurve(new[] { new Point(200, 100), new Point(300, 300), new Point(200, 400) });

			Pen p2 = new Pen(Color.FromArgb(128, Color.Red), 10);
			p2.DashStyle = DashStyle.Custom;
			p2.DashPattern = new float[] { 10, 5, 5, 5 };

			g.DrawPath(p2, path);

			g.FillPath(Brushes.Yellow, path);
		}
	}
}
